/*
 * Demo program for the RC_COPY
 * (c) 2011 by Simon Sunnyboy / Paradize
 */

#include <tos.h>
#include <stdlib.h>
#include "rccopy.h"

#define TIMER (*(unsigned long *)0x4BAUL)
#define IKBD (*(unsigned char*)0xFFFFFC02)

LINEA* linea_parm;

long mymain()
{
	uint16_t y;
	uint16_t *scr, *dscr;
	dscr = ( uint16_t * ) Physbase(); /* destination screen = visible screen */
	scr = dscr; /* source screen = visible screen (duh) */
	
	linea_parm = LineA_Init(); /* init Linea and save pointer to the linea variables */

	/* paint some 32pixel bar onscreen and reuse whatever is still onscreen: */
	for ( y = 0; y < 200; y++ )
	{
		*dscr = 0xFFFF;
		* ( dscr + 1 ) = 0;
		* ( dscr + 2 ) = 0;
		* ( dscr + 3 ) = 0;
		* ( dscr + 4 ) = 0;
		* ( dscr + 5 ) = 0;
		* ( dscr + 6 ) = 0;
		* ( dscr + 7 ) = 0xFFFF;
		dscr = dscr + 80; /* next scanline (160 bytes = 80 words = 80 uint16_t)*/
	}

	/* blit some asymetrical strip: */
	RC_COPY ( scr,120,0,7,32,scr,1,33,3 );

	/* blit a row of tiles: */
	for ( y= 0; y < 20; y ++ )
	{
		RC_COPY ( scr,y*16,0,16,16,scr,y*16,180,3 );
	}

	/* wait for keypress: */
	Bconin ( 2 );
	return 0;
}


int main()
{
	return ( Supexec ( mymain ) );
}

